<?php
/**
 * ProfileComments by Santiago Dimattia
 * http://www.teleportz.com.ar
 */

define('IN_MYBB', 1);
define('THIS_SCRIPT', 'update.php');

require_once './global.php';

$lang->load('profilecomments');

if(!$mybb->input['version'])
{
?>
	<h1>Profile Comments Updater</h1>
	<p>What version of ProfileComments were you using?</p>

	<form action="update.php" method="post">
		<select name="version">
			<option value="1">0.4.1 or less</option>
			<option value="2">0.5.0</option>
			<option value="3">0.5.1</option>
			<option value="4">0.6.0</option>
			<option value="5">0.7.0</option>
			<option value="6">0.7.1</option>
			<option value="7">0.9.0</option>
			<option value="8">0.9.1</option>
		</select>
		<input type="submit" value="Update" />
	</form
<?php
}
else
{
	$from = (int) $mybb->input['version'];

	if(!$from)
	{
		die('Invalid version!');
	}

	$updates = array(
		'1' => 'update_1',
		'2' => 'update_2',
		'3' => 'update_3',
		'4' => 'update_4',
		'5' => 'update_5',
		'6' => 'update_6',
		'7' => 'update_7',
		'8' => 'update_8',
	);

	foreach($updates as $version => $function)
	{
		if($from <= $version && !empty($function))
		{
			echo $function();
			echo "\n<br />\n";
		}
	}

	echo '<p>Congrats! ProfileComments is now updated to it\'s last version. Dont forget to delete this file.';
}

function updated_message($version)
{
	return 'ProfileComments was updated to ' . $version;
}

function update_1()
{
	// New comments alert
	$db->write_query("ALTER TABLE `".TABLE_PREFIX."users` DROP `visiteprofile`;");
	$db->write_query("ALTER TABLE `".TABLE_PREFIX."users` ADD `newcomments` INT(10) NOT NULL DEFAULT '0';");

	// New group-based permissions! :)
	$db->write_query("ALTER TABLE `".TABLE_PREFIX."usergroups` ADD `cansendcomments` INT(1) NOT NULL DEFAULT '0';");
	$db->write_query("ALTER TABLE `".TABLE_PREFIX."usergroups` ADD `caneditselfcomments` INT(1) NOT NULL DEFAULT '0';");
	$db->write_query("ALTER TABLE `".TABLE_PREFIX."usergroups` ADD `candeleteselfcomments` INT(1) NOT NULL DEFAULT '0';");

	// Give access to send and edit own comments to ALL USERGROUPS
	$db->write_query('UPDATE '.TABLE_PREFIX.'usergroups SET canmanagecomments = "0", cansendcomments = "1", caneditselfcomments = "1"');
	// Give access to EDIT & DELETE (all comments) to Administrators
	$db->write_query('UPDATE '.TABLE_PREFIX.'usergroups SET canmanagecomments = "1", candeleteselfcomments = "1" WHERE gid = "4"');
	// Delete all access for guests
	$db->write_query('UPDATE '.TABLE_PREFIX.'usergroups SET cansendcomments = "0", caneditselfcomments = "0" WHERE gid = "1"');
	// Delete all access for banned users
	$db->write_query('UPDATE '.TABLE_PREFIX.'usergroups SET cansendcomments = "0", caneditselfcomments = "0" WHERE gid = "7"');
	// Delete all access for 'awaiting activation' users
	$db->write_query('UPDATE '.TABLE_PREFIX.'usergroups SET cansendcomments = "0", caneditselfcomments = "0" WHERE gid = "5"');

	// Update usergroups cache
	$cache->update_usergroups();

	return updated_message('0.5.0');
}

function update_2()
{
	return updated_message('0.5.1');
}

function update_3()
{
	global $mybb, $db, $lang;
	
	$query = $db->simple_select('settinggroups', 'gid', 'name="profilecomments"');
	$group = $db->fetch_field($query, 'gid');
	
	// Create new values
	$new_config = array();
	
	$new_config[] = array(
		'name' => 'profilecomments_allow_html',
		'title' => $db->escape_string($lang->profile_comments_allow_html),
		'description' => $db->escape_string($lang->profile_comments_allow_html_info),
		'optionscode' => 'yesno',
		'value' => '0',
		'disporder' => 6,
		'gid' => $group
	);

	$new_config[] = array(
		'name' => 'profilecomments_allow_smilies',
		'title' => $db->escape_string($lang->profile_comments_allow_smilies),
		'description' => $db->escape_string($lang->profile_comments_allow_smilies_info),
		'optionscode' => 'yesno',
		'value' => '1',
		'disporder' => 7,
		'gid' => $group
	);

	$new_config[] = array(
		'name' => 'profilecomments_allow_bbcode',
		'title' => $db->escape_string($lang->profile_comments_allow_bbcode),
		'description' => $db->escape_string($lang->profile_comments_allow_bbcode_info),
		'optionscode' => 'yesno',
		'value' => '1',
		'disporder' => 8,
		'gid' => $group
	);
	
		$new_config[] = array(
		'name' => 'profilecomments_allow_imgcode',
		'title' => $db->escape_string($lang->profile_comments_allow_imgcode),
		'description' => $db->escape_string($lang->profile_comments_allow_imgcode_info),
		'optionscode' => 'yesno',
		'value' => '1',
		'disporder' => 9,
		'gid' => $group
	);
	
	$new_config[] = array(
		'name' => 'profilecomments_filter_badwords',
		'title' => $db->escape_string($lang->profile_comments_filter_badwords),
		'description' => $db->escape_string($lang->profile_comments_filter_badwords_info),
		'optionscode' => 'yesno',
		'value' => '1',
		'disporder' => 10,
		'gid' => $group
	);

	$new_config[] = array(
		'name' => 'profilecomments_show_editor',
		'title' => $db->escape_string($lang->profile_comments_show_editor),
		'description' => $db->escape_string($lang->profile_comments_show_editor_info),
		'optionscode' => 'yesno',
		'value' => '0',
		'disporder' => 10,
		'gid' => $group
	);
	
	foreach($new_config as $array => $content)
	{
		$db->insert_query("settings", $content);
	}
	
	rebuild_settings();
	
	return updated_message('0.6.0');
}

function update_4()
{
	global $db, $lang;

	// Delete NewComment bar inline style setting
	$db->delete_query('settings','name = "profilecomments_alertbar_style"');

	// Add new fields
	$db->write_query("ALTER TABLE `".TABLE_PREFIX."users` ADD `commentnotify` INT(10) NOT NULL DEFAULT '0';");
	$db->write_query("ALTER TABLE `".TABLE_PREFIX."users` ADD `commentsfilter` INT(10) NOT NULL DEFAULT '0';");

	$q = $db->simple_select('settinggroups', 'gid', 'name = "profilecomments"', array('limit' => 1));
	$group = $db->fetch_array($q);

	// Create new settings
	$new_config = array();
	$new_config[] = array(
		'name' => 'profilecomments_close_comments_on_banned',
		'title' => $db->escape_string($lang->profile_comments_close_on_banned),
		'description' => $db->escape_string($lang->profile_comments_close_on_banned_info),
		'optionscode' => 'yesno',
		'value' => '1',
		'disporder' => 12,
		'gid' => $group['gid']
	);

	$new_config[] = array(
		'name' => 'profilecomments_show_statistics',
		'title' => $db->escape_string($lang->profilecomments_show_statistics),
		'description' => $db->escape_string($lang->profilecomments_show_statistics_info),
		'optionscode' => 'yesno',
		'value' => '0',
		'disporder' => 13,
		'gid' => $group['gid']
	);

	$new_config[] = array(
		'name' => 'profilecomments_ajax',
		'title' => $db->escape_string($lang->profilecomments_ajax),
		'description' => $db->escape_string($lang->profilecomments_ajax_info),
		'optionscode' => 'yesno',
		'value' => '0',
		'disporder' => 14,
		'gid' => $group['gid']
	);

	foreach($new_config as $array => $content)
	{
		$db->insert_query("settings", $content);
	}

	rebuild_settings();

	return updated_message('0.7.0');
}

function update_5()
{
	return updated_message('0.7.1');
}

function update_6()
{
	return updated_message('0.9.0');
}

function update_7()
{
	return updated_message('0.9.1');
}

function update_8()
{
	global $db, $lang;

	// Fix for 0.9.2-dev002
	$db->delete_query('settings','name = "profilecomments_ignored_can_send_comments"');

	// Query the Group ID
	$q = $db->simple_select('settinggroups', 'gid', 'name = "profilecomments"', array('limit' => 1));
	$group = $db->fetch_array($q);
	
	// Insert new config
	$config = array(
		'name' => 'profilecomments_ignored_can_send_comments',
		'title' => $db->escape_string($lang->profile_comments_ignored_can_send_comments),
		'description' => $db->escape_string($lang->profile_comments_ignored_can_send_comments_info),
		'optionscode' => 'yesno',
		'value' => '1',
		'disporder' => 15,
		'gid' => $group['gid']
	);

	$db->insert_query("settings", $config);

	return updated_message('0.9.2');
}